config/routes.rb
Rails.application.routes.draw do
  get 'transactions/top_up'
  post 'transactions/do_top_up'
  get 'transactions/peer_transfer'
  post 'transactions/do_peer_transfer'
  get 'transactions/team_share'
  post 'transactions/do_team_share'
  get 'transactions/stock_invest'
  post 'transactions/do_stock_invest'
  get 'transactions/withdraw_team_share'
  post 'transactions/do_withdraw_team_share'
  get 'transactions/withdraw_stock_invest'
  post 'transactions/do_withdraw_stock_invest'
  get "wallet/show"

  resources :wallet
  resources :stocks
  resources :teams
  resources :users
  root 'users#index'
end

app/controllers/transactions_controller.rb
class TransactionsController < ApplicationController
  before_action :set_new_transaction, only: %i[ top_up peer_transfer team_share withdraw_team_share stock_invest withdraw_stock_invest ]
  before_action :set_transaction, only: %i[ do_top_up do_peer_transfer do_team_share do_withdraw_team_share do_stock_invest do_withdraw_stock_invest ]

  def top_up
  end

  def do_top_up
    if @transaction.valid?
      @wallet = Wallet.find(@transaction.wallet_id)
      if @wallet.top_up @transaction.amount
        redirect_to @wallet, notice: "Transaction success"
      else
        render :top_up
      end
    else
      render :top_up
    end
  end

  def peer_transfer
  end

  def do_peer_transfer
    if @transaction.valid?
      @wallet = Wallet.find(@transaction.wallet_id)
      @target_wallet = Wallet.find(@transaction.ref_wallet_id)
      if @wallet.peer_transfer_to @target_wallet, @transaction.amount, @transaction.notes
        redirect_to @wallet, notice: "Transaction success"
      else
        render :peer_transfer
      end
    else
      render :peer_transfer
    end
  end

  def team_share
  end

  def do_team_share
    if @transaction.valid?
      @wallet = Wallet.find(@transaction.wallet_id)
      @target_wallet = Wallet.find(@transaction.ref_wallet_id)
      if @wallet.transfer_to_team @target_wallet.owner, @transaction.amount
        redirect_to @wallet, notice: "Transaction success"
      else
        render :peer_transfer
      end
    else
      render :peer_transfer
    end
  end

  def withdraw_team_share
  end

  def do_withdraw_team_share
  end

  def stock_invest
    @investor_options = get_investor_options
  end

  def do_stock_invest
    if @transaction.valid?
      @wallet = Wallet.find(@transaction.wallet_id)
      @target_wallet = Wallet.find(@transaction.ref_wallet_id)
      if @wallet.transfer_to_stock @target_wallet.owner, @transaction.amount
        redirect_to @wallet, notice: "Transaction success"
      else
        render :peer_transfer
      end
    else
      render :peer_transfer
    end
  end

  def withdraw_stock_invest
  end

  def do_withdraw_stock_invest
  end

  private
    def set_new_transaction
      @transaction = Transaction.new
    end

    def set_transaction 
      @transaction = Transaction.new(transaction_params)
    end

    def transaction_params
      params.require(:transaction).permit(:wallet_id, :ref_wallet_id, :amount, :notes)
    end

    def get_investor_options
      
    users = []
      User.order(:name).each do |u|
        users << [ u.name, u.wallet.id ]
      end 

      teams = []
      Team.order(:name).each do |t|
        teams << [ t.name, t.wallet.id ]
      end

      { "Individual" => users, "Team" => teams }
    end
end

app/helpers/transactions_helper.rb
module TransactionsHelper
end

app/views/transactions/peer_transfer.html.erb
<h1>Peer Transfer</h1>

<%= form_with model: @transaction, url: transactions_do_peer_transfer_path do |form| %>
  <%= render 'shared/form_error', model: @transaction %>

  <div class="mb-3">
    <%= form.label :wallet_id, "From Whose Wallet?", class: "form-label" %>
    <%= form.select :wallet_id, User.order(:name).collect { |u| [ u.name, u.wallet.id ] }, { prompt: 'Select User' }, { class: 'form-select' } %>
  </div>

  <div class="mb-3">
    <%= form.label :ref_wallet_id, "To Whose Wallet?", class: "form-label" %>
    <%= form.select :ref_wallet_id, User.order(:name).collect { |u| [ u.name, u.wallet.id ] }, { prompt: 'Select User' }, { class: 'form-select' } %>
  </div>

  <div class="mb-3">
    <%= form.label :amount, "How Much?", class: "form-label" %>
    <%= form.number_field :amount, in: 100000..100000000, step: 100000, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.label :notes, "Message", class: "form-label" %>
    <%= form.text_field :notes, class: "form-control" %>
  </div>

  <div class="actions">
    <%= form.submit class: "btn btn-primary" %>
  </div>
<% end %>

app/views/transactions/stock_invest.html.erb
<h1>Invest on Stock</h1>

<%= form_with model: @transaction, url: transactions_do_stock_invest_path do |form| %>
  <%= render 'shared/form_error', model: @transaction %>

    <div class="mb-3">
        <%= form.label :wallet_id, "From Whose Wallet?", class: "form-label" %>
        <%= form.select :wallet_id, grouped_options_for_select(@investor_options), {}, { class: 'form-select' } %>
    </div>

    <div class="mb-3">
        <%= form.label :ref_wallet_id, "On Which Stock?", class: "form-label" %>
        <%= form.select :ref_wallet_id, Stock.order(:name).collect { |t| [ t.name, t.wallet.id ] }, { prompt: 'Select Team' }, { class: 'form-select' } %>
    </div>

    <div class="mb-3">
        <%= form.label :amount, "How Much?", class: "form-label" %>
        <%= form.number_field :amount, in: 100000..100000000, step: 100000, class: "form-control" %>
    </div>

    <div class="actions">
        <%= form.submit class: "btn btn-primary" %>
    </div>
<% end %>

app/views/transactions/team_share.html.erb
<h1>Join Team Share</h1>

<%= form_with model: @transaction, url: transactions_do_team_share_path do |form| %>
  <%= render 'shared/form_error', model: @transaction %>

  <div class="mb-3">
    <%= form.label :wallet_id, "From Whose Wallet?", class: "form-label" %>
    <%= form.select :wallet_id, User.order(:name).collect { |u| [ u.name, u.wallet.id ] }, { prompt: 'Select User' }, { class: 'form-select' } %>
  </div>

  <div class="mb-3">
    <%= form.label :ref_wallet_id, "To Which Team?", class: "form-label" %>
    <%= form.select :ref_wallet_id, Team.order(:name).collect { |t| [ t.name, t.wallet.id ] }, { prompt: 'Select Team' }, { class: 'form-select' } %>
  </div>

  <div class="mb-3">
    <%= form.label :amount, "How Much?", class: "form-label" %>
    <%= form.number_field :amount, in: 100000..100000000, step: 100000, class: "form-control" %>
  </div>

  <div class="actions">
    <%= form.submit class: "btn btn-primary" %>
  </div>
<% end %>

app/views/transactions/top_up.html.erb
<h1>Top-Up</h1>

<%= form_with model: @transaction, url: transactions_do_top_up_path do |form| %>
  <%= render 'shared/form_error', model: @transaction %>

  <div class="mb-3">
    <%= form.label :wallet_id, "Whose Wallet?", class: "form-label" %>
    <%= form.select :wallet_id, User.order(:name).collect { |u| [ u.name, u.wallet.id ] }, { prompt: 'Select User' }, { class: 'form-select' } %>
  </div>

  <div class="mb-3">
    <%= form.label :amount, "How Much?", class: "form-label" %>
    <%= form.number_field :amount, in: 100000..100000000, step: 100000, class: "form-control" %>
  </div>

  <div class="actions">
    <%= form.submit class: "btn btn-primary" %>
  </div>

  <%= form.hidden_field :ref_wallet_id, :value => 0 %>
<% end %>

app/views/transactions/withdraw_stock_invest.html.erb
<h1>Transactions#withdraw_stock_invest</h1>
<p>Find me in app/views/transactions/withdraw_stock_invest.html.erb</p>

app/views/transactions/withdraw_team_share.html.erb
<h1>Transactions#withdraw_team_share</h1>
<p>Find me in app/views/transactions/withdraw_team_share.html.erb</p>